// MSRDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SignPay_OPOSDemo.h"
#include "MSRDlg.h"
#include "Opos.h"
#include "CheckHealthDlg.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMSRDlg property page

IMPLEMENT_DYNCREATE(CMSRDlg, CPropertyPage)

CMSRDlg::CMSRDlg() : CPropertyPage(CMSRDlg::IDD)
{
	//{{AFX_DATA_INIT(CMSRDlg)
	m_sCODes = _T("");
	m_sSODes = _T("");
	m_sDeviceName = _T("");
	m_sDeviceDes = _T("");
	m_OpenEdit = _T("");
	m_bClaim = FALSE;
	m_bAutoDisable = FALSE;
	m_lCOVer = 0;
	m_lSOVer = 0;
	m_bDeviceEnable = FALSE;
	m_bFreeze = FALSE;
	m_bDataEvent = FALSE;
	m_sTrack1Data = _T("");
	m_iTrack1Len = 0;
	m_sTrack1Discretion = _T("");
	m_sTrack2Data = _T("");
	m_sTrack2Discretion = _T("");
	m_sTrack3Data = _T("");
	m_sTrack4Data = _T("");
	m_iTrack2Len = 0;
	m_iTrack3Len = 0;
	m_iTrack4Len = 0;
	m_strCheckHealth = _T("");
	m_sTrack1EnData = _T("");
	m_iTrack1EnLen = 0;
	m_sTrack2EnData = _T("");
	m_iTrack2EnLen = 0;
	m_sKSN = _T("");
	//}}AFX_DATA_INIT
}

CMSRDlg::~CMSRDlg()
{
}

void CMSRDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMSRDlg)
	DDX_Control(pDX, IDC_COMBO_MSRBINARY, m_MSRBinary);
	DDX_Control(pDX, IDC_COMBO_MSR, m_ComMSR);
	DDX_Control(pDX, IDC_MSR1, m_MSR);
	DDX_Text(pDX, IDC_EDIT_CODES, m_sCODes);
	DDX_Text(pDX, IDC_EDIT_SOVDES, m_sSODes);
	DDX_Text(pDX, IDC_EDIT_UDEVICENAME, m_sDeviceName);
	DDX_Text(pDX, IDC_EDIT_DEVICEDES, m_sDeviceDes);
	DDX_Text(pDX, IDC_EDIT_OPEN, m_OpenEdit);
	DDX_Check(pDX, IDC_CHECK_CLAIM, m_bClaim);
	DDX_Check(pDX, IDC_CHECK_AUDODISABLE, m_bAutoDisable);
	DDX_Text(pDX, IDC_EDIT_COVER, m_lCOVer);
	DDX_Text(pDX, IDC_EDIT_SOVER, m_lSOVer);
	DDX_Check(pDX, IDC_CHECK_DEVICEENABLE, m_bDeviceEnable);
	DDX_Check(pDX, IDC_CHECK_FREEZEEVENT, m_bFreeze);
	DDX_Check(pDX, IDC_CHECK_DATAEVENTENABLE, m_bDataEvent);
	DDX_Text(pDX, IDC_EDIT_TRACK1DATA, m_sTrack1Data);
	DDX_Text(pDX, IDC_EDIT_TRACK1DATALEN, m_iTrack1Len);
	DDX_Text(pDX, IDC_EDIT_TRACK1DISCRETIONARY, m_sTrack1Discretion);
	DDX_Text(pDX, IDC_EDIT_TRACK2DATA, m_sTrack2Data);
	DDX_Text(pDX, IDC_EDIT_TRACK2DISCRETIONARY, m_sTrack2Discretion);
	DDX_Text(pDX, IDC_EDIT_TRACK3DATA, m_sTrack3Data);
	DDX_Text(pDX, IDC_EDIT_TRACK4DATA, m_sTrack4Data);
	DDX_Text(pDX, IDC_EDIT_TRACK2DATALEN, m_iTrack2Len);
	DDX_Text(pDX, IDC_EDIT_TRACK3DATALEN, m_iTrack3Len);
	DDX_Text(pDX, IDC_EDIT_TRACK4DATALEN, m_iTrack4Len);
	DDX_Text(pDX, IDC_EDIT_CHECKHEALTH, m_strCheckHealth);
	DDX_Text(pDX, IDC_EDIT_TRACK1ENDATA, m_sTrack1EnData);
	DDX_Text(pDX, IDC_EDIT_TRACK1ENDATALEN, m_iTrack1EnLen);
	DDX_Text(pDX, IDC_EDIT_TRACK2ENDATA, m_sTrack2EnData);
	DDX_Text(pDX, IDC_EDIT_TRACK2ENDATALEN, m_iTrack2EnLen);
	DDX_Text(pDX, IDC_EDIT_KSN, m_sKSN);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMSRDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CMSRDlg)
	ON_BN_CLICKED(IDC_BTN_OPEN, OnBtnOpen)
	ON_BN_CLICKED(IDC_BTN_CLAIM, OnBtnClaim)
	ON_BN_CLICKED(IDC_CHECK_AUDODISABLE, OnCheckAudodisable)
	ON_BN_CLICKED(IDC_CHECK_DEVICEENABLE, OnCheckDeviceenable)
	ON_BN_CLICKED(IDC_CHECK_FREEZEEVENT, OnCheckFreezeevent)
	ON_BN_CLICKED(IDC_CHECK_DATAEVENTENABLE, OnCheckDataeventenable)
	ON_BN_CLICKED(IDC_BTN_CLEARPROPERTY, OnBtnClearproperty)
	ON_BN_CLICKED(IDC_BTN_CLEARINPUT, OnBtnClearinput)
	ON_BN_CLICKED(IDC_BTN_RELEASE, OnBtnRelease)
	ON_BN_CLICKED(IDC_BTN_CLOSE, OnBtnClose)
	ON_BN_CLICKED(IDC_BTN_CHECKHEALTH, OnBtnCheckhealth)
	ON_CBN_SELCHANGE(IDC_COMBO_MSRBINARY, OnSelchangeComboMsrbinary)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMSRDlg message handlers

BEGIN_EVENTSINK_MAP(CMSRDlg, CPropertyPage)
    //{{AFX_EVENTSINK_MAP(CMSRDlg)
	ON_EVENT(CMSRDlg, IDC_MSR1, 1 /* DataEvent */, OnDataEventMsr1, VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CMSRDlg::OnDataEventMsr1(long Status) 
{
	// TODO: Add your control notification handler code here
	m_sTrack1Data = m_MSR.GetTrack1Data();
	m_iTrack1Len = m_sTrack1Data.GetLength();
	m_sTrack1Discretion = m_MSR.GetTrack1DiscretionaryData();
	m_sTrack2Data = m_MSR.GetTrack2Data();
	m_iTrack2Len = m_sTrack2Data.GetLength();
	m_sTrack2Discretion = m_MSR.GetTrack2DiscretionaryData();
	m_sTrack3Data = m_MSR.GetTrack3Data();
	m_iTrack3Len = m_sTrack3Data.GetLength();
	m_sTrack4Data = m_MSR.GetTrack4Data();
	m_iTrack4Len = m_sTrack4Data.GetLength();

	m_sTrack1EnData = m_MSR.GetTrack1EncryptedData();
	m_iTrack1EnLen = m_MSR.GetTrack1EncryptedDataLength();
	
	m_sTrack2EnData = m_MSR.GetTrack2EncryptedData();
	m_iTrack2EnLen = m_MSR.GetTrack2EncryptedDataLength();
	m_sKSN = m_MSR.GetAdditionalSecurityInformation();
	m_bDeviceEnable = m_MSR.GetDeviceEnabled();
//	m_MSR.SetDeviceEnabled(true);
	m_MSR.SetDataEventEnabled(true);

	UpdateData(false);

}

void CMSRDlg::OnBtnOpen() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	int res = 0;
	int index = m_ComMSR.GetCurSel();
	if(index == 0)
		res = m_MSR.Open(_T("MSR_Sign&Pay-HID"));
	else
		res = m_MSR.Open(_T("MSR_Sign&Pay-RS232"));
	if(res == OPOS_SUCCESS)
	{
		m_OpenEdit = "OPEN_SUCCESS";
		m_sCODes = m_MSR.GetControlObjectDescription();
		m_lCOVer = m_MSR.GetControlObjectVersion();
		m_sSODes = m_MSR.GetServiceObjectDescription();
		m_lSOVer = m_MSR.GetServiceObjectVersion();
		m_sDeviceDes = m_MSR.GetDeviceDescription();
		m_sDeviceName = m_MSR.GetDeviceName();
	

	}
	else if(res == OPOS_E_NOSERVICE)
			m_OpenEdit = "OPOS_E_NOSERVICE";
	else
	{
		int nres = m_MSR.GetOpenResult();
		switch(nres)
		{	
		case OPOS_OR_REGBADNAME:
			m_OpenEdit = "Device name is not exist";
			break;
		case OPOS_OR_FAILEDOPEN:
			m_OpenEdit = "OPOS_OR_FAILEDOPEN";
			break;
		case OPOS_ORS_NOPORT:
			m_OpenEdit = "OPOS_ORS_NOPORT";
			break;
		case OPOS_ORS_CONFIG:
			m_OpenEdit = "OPOS_ORS_CONFIG";
			break;
		default:
			m_OpenEdit = "OPEN_ERROR";
			break;
		}
	}
	UpdateData(FALSE);
}

void CMSRDlg::OnBtnClaim() 
{
	// TODO: Add your control notification handler code here
	int res = m_MSR.ClaimDevice(100);
	m_bClaim = m_MSR.GetClaimed();	
	
	UpdateData(FALSE);
	
}

void CMSRDlg::OnCheckAudodisable() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_bAutoDisable)
	{
		m_MSR.SetAutoDisable(true);
	}
	else
	{
		m_MSR.SetAutoDisable(false);
	}
}

void CMSRDlg::OnCheckDeviceenable() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_bDeviceEnable)
	{
		m_MSR.SetDeviceEnabled(true);
	}
	else
	{
		m_MSR.SetDeviceEnabled(false);
	}
}

void CMSRDlg::OnCheckFreezeevent() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	m_MSR.SetFreezeEvents(m_bFreeze);
}

void CMSRDlg::OnCheckDataeventenable() 
{
	UpdateData(true);
	m_MSR.SetDataEventEnabled(m_bDataEvent);	
}

void CMSRDlg::OnBtnClearproperty() 
{
	// TODO: Add your control notification handler code here
	m_MSR.ClearInputProperties();
}

void CMSRDlg::OnBtnClearinput() 
{
	// TODO: Add your control notification handler code here
	m_MSR.ClearInput();
}

void CMSRDlg::OnBtnRelease() 
{
	// TODO: Add your control notification handler code here
	m_MSR.ReleaseDevice();
	m_bClaim = false;
	m_bDeviceEnable = false;
	m_bDataEvent = FALSE;
	UpdateData(false);
}

void CMSRDlg::OnBtnClose() 
{
	// TODO: Add your control notification handler code here
	m_sCODes = _T("");
	m_sSODes = _T("");
	m_sDeviceName = _T("");
	m_sDeviceDes = _T("");
	m_OpenEdit = _T("");
	m_bClaim = FALSE;
	m_bAutoDisable = FALSE;
	m_lCOVer = 0;
	m_lSOVer = 0;
	m_bDeviceEnable = FALSE;
	m_bFreeze = FALSE;
	m_bDataEvent = FALSE;
	m_sTrack1Data = _T("");
	m_iTrack1Len = 0;
	m_sTrack1Discretion = _T("");
	m_sTrack2Data = _T("");
	m_iTrack2Len = 0;
	m_sTrack2Discretion = _T("");
	m_sTrack3Data = _T("");
	m_iTrack3Len = 0;
	m_sTrack4Data = _T("");
	m_iTrack4Len = 0;
	m_sTrack1EnData = _T("");
	m_iTrack1EnLen = 0;
	m_sTrack2EnData = _T("");
	m_sKSN = "";
	m_iTrack2EnLen = 0;
	m_MSR.Close();
	
	UpdateData(false);
}

void CMSRDlg::OnBtnCheckhealth() 
{
	// TODO: Add your control notification handler code here
	CCheckHealthDlg dlg;
	int nResult = 0;
	LONG lCheckLevel, lRet;
	nResult = dlg.DoModal();
	if(nResult == IDCANCEL)
		return;
	lCheckLevel = dlg.m_lCheckLevel;
	lRet = m_MSR.CheckHealth(lCheckLevel);
	m_strCheckHealth = m_MSR.GetCheckHealthText();
	UpdateData(false);

}

BOOL CMSRDlg::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_ComMSR.SetCurSel(0);
	m_MSRBinary.SetCurSel(0);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMSRDlg::OnSelchangeComboMsrbinary() 
{
	// TODO: Add your control notification handler code here
	int index = m_MSRBinary.GetCurSel();
	if(index == 0)
		m_MSR.SetBinaryConversion(OPOS_BC_NONE);
	else if(index == 1)
		m_MSR.SetBinaryConversion(OPOS_BC_NIBBLE);
	else
		m_MSR.SetBinaryConversion(OPOS_BC_DECIMAL);

}
