//{{AFX_INCLUDES()
#include "oposmsr1.h"
//}}AFX_INCLUDES
#if !defined(AFX_MSRDLG_H__FE714C54_BD64_44AB_9917_1C6F187CA993__INCLUDED_)
#define AFX_MSRDLG_H__FE714C54_BD64_44AB_9917_1C6F187CA993__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MSRDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMSRDlg dialog

class CMSRDlg : public CPropertyPage
{
	DECLARE_DYNCREATE(CMSRDlg)

// Construction
public:
	CMSRDlg();
	~CMSRDlg();

// Dialog Data
	//{{AFX_DATA(CMSRDlg)
	enum { IDD = IDD_MSRDLG };
	CComboBox	m_MSRBinary;
	CComboBox	m_ComMSR;
	COPOSMSR	m_MSR;
	CString	m_sCODes;
	CString	m_sSODes;
	CString	m_sDeviceName;
	CString	m_sDeviceDes;
	CString	m_OpenEdit;
	BOOL	m_bClaim;
	BOOL	m_bAutoDisable;
	long	m_lCOVer;
	long	m_lSOVer;
	BOOL	m_bDeviceEnable;
	BOOL	m_bFreeze;
	BOOL	m_bDataEvent;
	CString	m_sTrack1Data;
	int		m_iTrack1Len;
	CString	m_sTrack1Discretion;
	CString	m_sTrack2Data;
	CString	m_sTrack2Discretion;
	CString	m_sTrack3Data;
	CString	m_sTrack4Data;
	int		m_iTrack2Len;
	int		m_iTrack3Len;
	int		m_iTrack4Len;
	CString	m_strCheckHealth;
	CString	m_sTrack1EnData;
	int		m_iTrack1EnLen;
	CString	m_sTrack2EnData;
	int		m_iTrack2EnLen;
	CString	m_sKSN;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CMSRDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CMSRDlg)
	afx_msg void OnDataEventMsr1(long Status);
	afx_msg void OnBtnOpen();
	afx_msg void OnBtnClaim();
	afx_msg void OnCheckAudodisable();
	afx_msg void OnCheckDeviceenable();
	afx_msg void OnCheckFreezeevent();
	afx_msg void OnCheckDataeventenable();
	afx_msg void OnBtnClearproperty();
	afx_msg void OnBtnClearinput();
	afx_msg void OnBtnRelease();
	afx_msg void OnBtnClose();
	afx_msg void OnBtnCheckhealth();
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeComboMsrbinary();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MSRDLG_H__FE714C54_BD64_44AB_9917_1C6F187CA993__INCLUDED_)
