// uSignDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SignPay_OPOSDemo.h"
#include "uSignDlg.h"
#include "Opos.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CuSignDlg property page

IMPLEMENT_DYNCREATE(CuSignDlg, CPropertyPage)

CuSignDlg::CuSignDlg() : CPropertyPage(CuSignDlg::IDD)
{
	//{{AFX_DATA_INIT(CuSignDlg)
	m_uCoDes = _T("");
	m_uSoDes = _T("");
	m_uCoVer = 0;
	m_uSoVer = 0;
	m_DeviceName = _T("");
	m_DeviceDes = _T("");
	m_bClaim = FALSE;
	m_bDeviceEnable = FALSE;
	m_bDataEvent = FALSE;
	m_bFreeze = FALSE;
	m_bRealTime = FALSE;
	m_bCapDisplay = FALSE;
	m_bCapRealTime = FALSE;
	m_bCapUser = FALSE;
	m_RawData = _T("");
	m_bAutoDisable = FALSE;
	m_lState = _T("");
	m_sPowerNotify = _T("");
	m_sPowerState = _T("");
	m_lDataCount = 0;
	m_sCapPower = _T("");
	m_lMaxX = 0;
	m_lMaxY = 0;
	m_sPontArray = _T("");
	//}}AFX_DATA_INIT
}

CuSignDlg::~CuSignDlg()
{
}

void CuSignDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CuSignDlg)
	DDX_Control(pDX, IDC_COMBO_USIGN, m_ComuSign);
	DDX_Control(pDX, IDC_COMBO_BINARY, m_cBinary);
	DDX_Control(pDX, IDC_SIGCAP1, m_uSignPos);
	DDX_Text(pDX, IDC_EDIT_CODES, m_uCoDes);
	DDX_Text(pDX, IDC_EDIT_SOVDES, m_uSoDes);
	DDX_Text(pDX, IDC_EDIT_COVER, m_uCoVer);
	DDX_Text(pDX, IDC_EDIT_SOVER, m_uSoVer);
	DDX_Text(pDX, IDC_EDIT_UDEVICENAME, m_DeviceName);
	DDX_Text(pDX, IDC_EDIT_DEVICEDES, m_DeviceDes);
	DDX_Check(pDX, IDC_CHECK_CLAIM, m_bClaim);
	DDX_Check(pDX, IDC_CHECK_DEVICEENABLE, m_bDeviceEnable);
	DDX_Check(pDX, IDC_CHECK_DATAEVENT, m_bDataEvent);
	DDX_Check(pDX, IDC_CHECK_FREEZE, m_bFreeze);
	DDX_Check(pDX, IDC_CHECK_REALTIME, m_bRealTime);
	DDX_Check(pDX, IDC_CHECK_CAPDISPLAY, m_bCapDisplay);
	DDX_Check(pDX, IDC_CHECK_CAPREALTIME, m_bCapRealTime);
	DDX_Check(pDX, IDC_CHECK_CAPUSER, m_bCapUser);
	DDX_Text(pDX, IDC_EDIT_RAWDATA, m_RawData);
	DDX_Check(pDX, IDC_CHECK_AUDODISABLE, m_bAutoDisable);
	DDX_Text(pDX, IDC_EDIT_STATE, m_lState);
	DDX_Text(pDX, IDC_EDIT_POWERNOTIFY, m_sPowerNotify);
	DDX_Text(pDX, IDC_EDIT_POWERSTATE, m_sPowerState);
	DDX_Text(pDX, IDC_EDIT_DATACOUNT, m_lDataCount);
	DDX_Text(pDX, IDC_EDIT_POWERREPORTING, m_sCapPower);
	DDX_Text(pDX, IDC_EDIT_MAXX, m_lMaxX);
	DDX_Text(pDX, IDC_EDIT_MAXY, m_lMaxY);
	DDX_Text(pDX, IDC_EDIT_POINTARRAY, m_sPontArray);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CuSignDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CuSignDlg)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON_OPEN, OnButtonOpen)
	ON_BN_CLICKED(IDC_BUTTON_UCLOSE, OnButtonUclose)
	ON_BN_CLICKED(IDC_BUTTON_CLAIM, OnButtonClaim)
	ON_BN_CLICKED(IDC_CHECK_DEVICEENABLE, OnCheckDeviceenable)
	ON_BN_CLICKED(IDC_CHECK_DATAEVENT, OnCheckDataevent)
	ON_BN_CLICKED(IDC_CHECK_FREEZE, OnCheckFreeze)
	ON_BN_CLICKED(IDC_CHECK_REALTIME, OnCheckRealtime)
	ON_BN_CLICKED(IDC_BUTTON_BEGIN, OnButtonBegin)
	ON_BN_CLICKED(IDC_BUTTON_END, OnButtonEnd)
	ON_BN_CLICKED(IDC_BUTTON_USIGNRELEASE, OnButtonUsignrelease)
	ON_BN_CLICKED(IDC_CHECK_AUDODISABLE, OnCheckAudodisable)
	ON_CBN_SELCHANGE(IDC_COMBO_BINARY, OnSelchangeComboBinary)
	ON_BN_CLICKED(IDC_BUTTON_CLEARINPUT, OnButtonClearinput)
	ON_BN_CLICKED(IDC_BUTTON_CLEARPRO, OnButtonClearpro)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CuSignDlg message handlers

BOOL CuSignDlg::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_cBinary.SetCurSel(0);
	m_ComuSign.SetCurSel(0);
	p_Count = 0;
	p_Draw = 0;
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CuSignDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	if(p_Count > 0)
	{
		int iWidth = 245;
		int iHeight = 65;
		int xshift = 0;
		int yshift = 0;
		long x1,x2,y1,y2;
		CPoint p1,p2;
		for(int i = 0; i < p_Count-1; i++)
		{
			p1 = m_pArray[i];			
			p2 = m_pArray[i+1];
		
			x1 = (long)(p1.x *1.6* (float)(iWidth/1024.0)) + xshift;
			x2 = (long)(p2.x *1.6* (float)(iWidth/1024.0)) + xshift;
			y1 = (long)(p1.y *1.6* (float)(iHeight/1024.0)) + yshift;
			y2 = (long)(p2.y *1.6* (float)(iHeight/1024.0)) + yshift;
		
			if((p1.x != -1) && (p1.y != -1) && (p1.x <= 1024) && (p1.y <= 1024) && (p1.x >= 0) && (p1.y >= 0))
			{
				if ((p2.x != -1) && (p2.y != -1) && (p2.x <= 1024) && (p2.y <= 1024))
				{
			
					dc.MoveTo(x1, y1);
					dc.LineTo(x2, y2); 
				}
				else
				{
					dc.SetPixel(x1, y1, RGB(0, 0, 0));
				
				}
			}
		}
		
		p_Draw = 0;
	}
	// TODO: Add your message handler code here
	
	// Do not call CPropertyPage::OnPaint() for painting messages
}
void CuSignDlg::UpdateState()
{
	switch(m_uSignPos.GetState())
	{
	case OPOS_S_CLOSED:
		m_lState = "OPOS_S_CLOSED";
		break;
	case OPOS_S_IDLE:
		m_lState = "OPOS_S_IDLE";
		break;
	case OPOS_S_BUSY:
		m_lState = "OPOS_S_BUSY";
		break;
	case OPOS_S_ERROR:
		m_lState = "OPOS_S_ERROR";
		break;
	default:
		m_lState = "Unknow Error";
		break;

	}
	long m_lNotify = m_uSignPos.GetPowerNotify();
	if(m_lNotify == OPOS_PN_ENABLED)
		m_sPowerNotify = "Enbaled";
	else
		m_sPowerNotify = "Disable";
	long m_lPState = m_uSignPos.GetPowerState();
	switch(m_lPState)
	{
	case OPOS_PS_ONLINE:
		m_sPowerState = "ONLINE";
		break;
	case OPOS_PS_OFF:
		m_sPowerState = "OFF";
		break;
	case OPOS_PS_OFFLINE:
		m_sPowerState = "OFFLINE";
		break;
	case OPOS_PS_OFF_OFFLINE:
		m_sPowerState = "OFF_OFFLINE";
		break;
	default:
		m_sPowerState = "UNKNOWN";
		break;
	}
	m_lDataCount = m_uSignPos.GetDataCount();
	long m_lCapPower = m_uSignPos.GetCapPowerReporting();
	switch(m_lCapPower)
	{
	case OPOS_PR_NONE:
		m_sCapPower = "NONE";
		break;
	case OPOS_PR_STANDARD:
		m_sCapPower = "STANDARD";
		break;
	case OPOS_PR_ADVANCED:
		m_sCapPower = "ADVANCED";
		break;
	default:
		m_sCapPower = "";
	}
	m_lMaxX = m_uSignPos.GetMaximumX();
	m_lMaxY = m_uSignPos.GetMaximumY();

	UpdateData(false);
}

void CuSignDlg::OnButtonOpen() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	int res = 0;
	int index = m_ComuSign.GetCurSel();
	if(index == 0)
		res = m_uSignPos.Open("uSign_Sign&Pay-HID");
	else
		res = m_uSignPos.Open("uSign_Sign&Pay-RS232");
	if(res == OPOS_SUCCESS)
	{		
		m_uCoDes = m_uSignPos.GetControlObjectDescription();
		m_uCoVer = m_uSignPos.GetControlObjectVersion();
		m_uSoDes = m_uSignPos.GetServiceObjectDescription();
		m_uSoVer = m_uSignPos.GetServiceObjectVersion();
		m_DeviceDes = m_uSignPos.GetDeviceDescription();
		m_DeviceName = m_uSignPos.GetDeviceName();
		m_bCapRealTime =	m_uSignPos.GetCapRealTimeData();
		m_bCapDisplay = m_uSignPos.GetCapDisplay();
		m_bCapUser = m_uSignPos.GetCapUserTerminated();
		UpdateState();
	}
	else
	{
		int nres = m_uSignPos.GetOpenResult();
		switch(nres)
		{	
		case OPOS_OR_REGBADNAME:
			m_uCoDes = "Device name is not exist";
			break;
		case OPOS_OR_FAILEDOPEN:
			m_uCoDes = "OPOS_OR_FAILEDOPEN";
			break;
		case OPOS_ORS_NOPORT:
			m_uCoDes = "OPOS_ORS_NOPORT";
			break;
		case OPOS_ORS_CONFIG:
			m_uCoDes = "OPOS_ORS_CONFIG";
			break;
		default:
			m_uCoDes = "OPEN_ERROR";
			break;
		}
	}
	UpdateData(FALSE);
}

BEGIN_EVENTSINK_MAP(CuSignDlg, CPropertyPage)
    //{{AFX_EVENTSINK_MAP(CuSignDlg)
	ON_EVENT(CuSignDlg, IDC_SIGCAP1, 1 /* DataEvent */, OnDataEventSigcap1, VTS_I4)
	
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CuSignDlg::OnDataEventSigcap(long Status) 
{
	// TODO: Add your control notification handler code here
	MessageBox("123");
}

void CuSignDlg::OnButtonUclose() 
{
	// TODO: Add your control notification handler code here
	m_uCoDes = _T("");
	m_uSoDes = _T("");
	m_uCoVer = 0;
	m_uSoVer = 0;
	m_DeviceName = _T("");
	m_DeviceDes = _T("");
	m_bClaim = FALSE;
	m_bDeviceEnable = FALSE;
	m_bDataEvent = FALSE;
	m_bFreeze = FALSE;
	m_bRealTime = FALSE;
	m_bCapDisplay = FALSE;
	m_bCapRealTime = FALSE;
	m_bCapUser = FALSE;
	m_RawData = _T("");
	m_bAutoDisable = FALSE;
	m_lState = _T("");
	m_sPowerNotify = _T("");
	m_sPowerState = _T("");
	m_lDataCount = 0;
	m_sCapPower = _T("");
	m_lMaxX = 0;
	m_lMaxY = 0;
	m_sPontArray = _T("");
	///////////////////////////
		m_bClaim = false;
		m_bDeviceEnable = false;	
		m_bCapRealTime = false;
		m_bCapDisplay = false;
		m_bCapUser = false;
		m_bDataEvent = false;
		m_bRealTime = false;
		m_bAutoDisable = false;
		m_uSignPos.Close();
		UpdateState();
		UpdateData(false);
}

void CuSignDlg::OnButtonClaim() 
{
	// TODO: Add your control notification handler code here
	int res = m_uSignPos.ClaimDevice(100);
	if(res == OPOS_SUCCESS)
	{
		m_bClaim = true;
	}
	UpdateData(false);
}

void CuSignDlg::OnCheckDeviceenable() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_bDeviceEnable)
	{
		m_uSignPos.SetDeviceEnabled(true);
	}
	else
	{
		m_uSignPos.SetDeviceEnabled(false);
	}
}

void CuSignDlg::OnCheckDataevent() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	m_uSignPos.SetDataEventEnabled(m_bDataEvent);
}

void CuSignDlg::OnCheckFreeze() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	m_uSignPos.SetFreezeEvents(m_bFreeze);
}

void CuSignDlg::OnCheckRealtime() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	m_uSignPos.SetRealTimeDataEnabled(m_bRealTime);
}

void CuSignDlg::OnButtonBegin() 
{
	// TODO: Add your control notification handler code here
	m_uSignPos.BeginCapture("123");
}

void CuSignDlg::OnButtonEnd() 
{
	// TODO: Add your control notification handler code here
	m_uSignPos.EndCapture();
	m_RawData = m_uSignPos.GetPointArray();
	m_sPontArray = m_uSignPos.GetPointArray();
	p_Count = 0;
	p_Draw = 0;
	m_pArray.RemoveAll();
	Invalidate(TRUE);
	UpdateData(false);
}

void CuSignDlg::OnDataEventSigcap1(long Status) 
{
	// TODO: Add your control notification handler code here
	int buf[256];
	int rev = 0;
	m_uSignPos.SetDataEventEnabled(true);
	m_RawData = m_uSignPos.GetRawData();
	m_sPontArray = m_uSignPos.GetPointArray();
	CString str = m_sPontArray;
	if(m_uSignPos.GetBinaryConversion() == OPOS_BC_NONE)
	{
		for(int j = 0; j < str.GetLength()-1; )
		{
			unsigned char xy1 = (unsigned char)str.GetAt(j);
			unsigned char xy2 = (unsigned char)str.GetAt(j+1);
			if(xy1 == 0xFF && xy2 == 0xFF)
				buf[rev++] = -1;
			else
				buf[rev++] = xy1 + xy2 * 256;
			j = j + 2;
		}
	}
	else if(m_uSignPos.GetBinaryConversion() == OPOS_BC_NIBBLE)
	{
		for(int j = 0; j < str.GetLength()-3; )
		{
			unsigned char xy1 = (str.GetAt(j) -48)*16;
			unsigned char xy2 = (str.GetAt(j+1) -48);
			unsigned char xy3 = (str.GetAt(j+2) -48)*16;
			unsigned char xy4 = (str.GetAt(j+3) -48);
			buf[rev++] = xy1 + xy2 + (xy3 + xy4) * 256;
			j = j + 4;

		}
	}
	else
	{
		for(int j = 0; j < str.GetLength()-5; )
		{
			unsigned char xy1_1 = str.GetAt(j) -48;
			unsigned char xy1_2 = str.GetAt(j+1) -48;
			unsigned char xy1_3 = str.GetAt(j+2) -48;
			unsigned char xy2_1 = str.GetAt(j+3) -48;
			unsigned char xy2_2 = str.GetAt(j+4) -48;
			unsigned char xy2_3 = str.GetAt(j+5) -48;
			unsigned char xy1 = xy1_3 + xy1_2*10 + xy1_1*100;
			unsigned char xy2 = xy2_3 + xy2_2*10 + xy2_1*100;
			buf[rev++] = xy1 + xy2 * 256;
			j = j + 6;
		}
	}
	p_Draw = 0;
	memset(p_Array, 0, 50);	
	CPoint p;
	for(int i = 0; i < rev;)
	{
		p.x = buf[i++];
		p.y = buf[i++];	
		m_pArray.Add(p);
		p_Count++;
		p_Draw++;
	}
	ClearRect(false);
	UpdateData(false);
}

void CuSignDlg::ClearRect(BOOL f_Rect)
{
	CRect rect;
	GetDlgItem(IDC_DRAWSTATIC)->GetClientRect(&rect);
	rect.right += 30;
	rect.bottom += 30;
	InvalidateRect(&rect,f_Rect);
}
void CuSignDlg::OnButtonUsignrelease() 
{
	// TODO: Add your control notification handler code here
	m_uSignPos.ReleaseDevice();
	m_bClaim = false;
	m_bDeviceEnable = false;
	UpdateData(false);
}

void CuSignDlg::OnCheckAudodisable() 
{
	// TODO: Add your control notification handler code here
	
	UpdateData(TRUE);
	if(m_bAutoDisable)
	{
		m_uSignPos.SetAutoDisable(true);
	}
	else
	{
		m_uSignPos.SetAutoDisable(false);
	}
}


void CuSignDlg::OnSelchangeComboBinary() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	int index = m_cBinary.GetCurSel();
	if(index == 0)
		m_uSignPos.SetBinaryConversion(OPOS_BC_NONE);
	else if(index == 1)
		m_uSignPos.SetBinaryConversion(OPOS_BC_NIBBLE);
	else
		m_uSignPos.SetBinaryConversion(OPOS_BC_DECIMAL);
}

void CuSignDlg::OnButtonClearinput() 
{
	// TODO: Add your control notification handler code here

	m_uSignPos.ClearInput();
}

void CuSignDlg::OnButtonClearpro() 
{
	// TODO: Add your control notification handler code here
	m_uSignPos.ClearInputProperties();
	
}
